Ada Reference Manual (Ada 2022) — Legal Information

# 12.5.2 Formal Scalar Types

1/2
A formal scalar type is one defined by any of the formal_type_definitions in this subclause. The category determined for a formal scalar type is the category of all discrete, signed integer, modular, floating point, ordinary fixed point, or decimal types.

#### Syntax

2
formal_discrete_type_definition ::= (<>)
3
formal_signed_integer_type_definition ::= range <>
4
formal_modular_type_definition ::= mod <>
5
formal_floating_point_definition ::= digits <>
6
formal_ordinary_fixed_point_definition ::= delta <>
7
formal_decimal_fixed_point_definition ::= delta <> digits <>

#### Legality Rules

8
The actual type for a formal scalar type shall not be a nonstandard numeric type.

Ada 2005 and 2012 Editions sponsored in part by Ada-Europe